﻿using System.Collections;
using System.Collections.Generic;
using System.Linq;
using Was.OrcSearch.Models.Interfaces;

namespace Was.OrcSearch.Models
{
    public abstract class MetadataCollectionBase : IMetadataCollection
    {
        public abstract IEnumerable<IMetadata> All { get; }

        public virtual IMetadata GetMetadata(string metadataName)
        {
            return All.FirstOrDefault(x => string.Equals(x.Name, metadataName));
        }

        IEnumerator<IMetadata> IEnumerable<IMetadata>.GetEnumerator()
        {
            return All.GetEnumerator();
        }

        IEnumerator IEnumerable.GetEnumerator()
        {
            return All.GetEnumerator();
        }
    }
}